/**
 * (C) 2011-2012 Alibaba Group Holding Limited.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * version 2 as published by the Free Software Foundation.
 *
 */
package com.taobao.common.tedis.core;

import java.util.List;
import java.util.concurrent.TimeUnit;

/**
 * List,ʱԵһ
 * @author juxin.zj E-mail:juxin.zj@taobao.com
 * @since 2011-7-25 11:54:33
 * @version 1.0
 */
public interface ListCommands {

    /**
     * ȡListд<tt>start</tt><tt>end</tt><br />
     * <tt>start</tt><tt>end</tt>ָ<br />
     * 磺<code>range(1,somekey, 0, 10)</code>ȡõ11<br />
     * <tt>start</tt><tt>end</tt>Ϊʾеļ<br />
     * 磺<code>range(1,somekey, -2, -1)</code>ȡõǵ2
     * @param namespace
     * @param key
     * @param start
     * @param end
     * @return
     */
    <K, V> List<V> range(int namespace, K key, long start, long end);

    /**
     * ضList<tt>start</tt>ʼ<tt>end</tt>
     * @param namespace
     * @param key
     * @param start
     * @param end
     */
    <K, V> void trim(int namespace, K key, long start, long end);

    /**
     * ȡListС
     * @param namespace
     * @param key
     * @return
     */
    <K, V> Long size(int namespace, K key);

    /**
     * Ӷͷһ
     * @param namespace
     * @param key
     * @param value
     * @return
     */
    <K, V> Long leftPush(int namespace, K key, V... value);

    /**
     * Ӷieͷһݣ<tt>key</tt>ڲŲ
     * @param namespace
     * @param key
     * @param value
     * @return
     */
    <K, V> Long leftPushIfPresent(int namespace, K key, V value);

    /**
     * <tt>pivot</tt>֮ǰһ
     * @param namespace
     * @param key
     * @param pivot
     * @param value
     * @return
     */
    <K, V> Long leftInsert(int namespace, K key, V pivot, V value);

    /**
     * ڶβһ
     * @param namespace
     * @param key
     * @param value
     * @return
     */
    <K, V> Long rightPush(int namespace, K key, V... value);

    /**
     * ڶβһݣ<tt>key</tt>ڲŲ
     * @param namespace
     * @param key
     * @param value
     * @return
     */
    <K, V> Long rightPushIfPresent(int namespace, K key, V value);

    /**
     * <tt>pivot</tt>֮һ
     * @param namespace
     * @param key
     * @param pivot
     * @param value
     * @return
     */
    <K, V> Long rightInsert(int namespace, K key, V pivot, V value);

    /**
     * λ<tt>index</tt>ֵ
     * @param namespace
     * @param key
     * @param index
     * @param value
     */
    <K, V> void set(int namespace, K key, long index, V value);

    /**
     * ɾList<tt>i</tt>ֵΪ<tt>value</tt>
     * <ul>
     *  <li>i0Ӷͷʼɾi</li>
     *  <li>iС0Ӷβʼɾi</li>
     *  <li>i0ɾֵΪ<tt>value</tt></li>
     * </ul>
     * @param namespace
     * @param key
     * @param i
     * @param value
     * @return
     */
    <K, V> Long remove(int namespace, K key, long i, Object value);

    /**
     * ȡλ<tt>index</tt>
     * @param namespace
     * @param key
     * @param index
     * @return
     */
    <K, V> V index(int namespace, K key, long index);

    /**
     * ɾȡͷһݣnull
     * @param namespace
     * @param key
     * @return
     */
    <K, V> V leftPop(int namespace, K key);

    /**
     * ɾȡͷһݣȴָĳʱʱ<br />
     * <tt>timeout</tt>Ϊ0ʾʱ
     * @param namespace
     * @param key
     * @param timeout
     * @param unit
     * @return
     */
    <K, V> V leftPop(int namespace, K key, long timeout, TimeUnit unit);

    /**
     * ɾȡβһݣnull
     * @param namespace
     * @param key
     * @return
     */
    <K, V> V rightPop(int namespace, K key);

    /**
     * ɾȡβһݣȴָĳʱʱ<br />
     * <tt>timeout</tt>Ϊ0ʾʱ
     * @param namespace
     * @param key
     * @param timeout
     * @param unit
     * @return
     */
    <K, V> V rightPop(int namespace, K key, long timeout, TimeUnit unit);

    /**
     * <tt>sourceKey</tt>βһɾ뵽<tt>destinationKey</tt>ͷҽݷأݲnull
     * @param namespace
     * @param sourceKey
     * @param destinationKey
     * @return
     */
    <K, V> V rightPopAndLeftPush(int namespace, K sourceKey, K destinationKey);

    /**
     * <tt>sourceKey</tt>βһɾ뵽<tt>destinationKey</tt>ͷҽݷأݲȴָʱ
     * <tt>timeout</tt>Ϊ0ʾʱ
     * @param namespace
     * @param sourceKey
     * @param destinationKey
     * @param timeout
     * @param unit
     * @return
     */
    <K, V> V rightPopAndLeftPush(int namespace, K sourceKey, K destinationKey, long timeout, TimeUnit unit);

}
