/**
 * (C) 2011-2012 Alibaba Group Holding Limited.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * version 2 as published by the Free Software Foundation.
 *
 */
package com.taobao.common.tedis.core;

import java.util.Collection;
import java.util.List;
import java.util.Map;
import java.util.concurrent.TimeUnit;

/**
 * String
 * 
 * @author juxin.zj E-mail:juxin.zj@taobao.com
 * @since 2011-8-4 09:07:01
 * @version 1.0
 */
public interface StringCommands {

    /**
     * Ϊ<tt>key</tt>String׷<tt>value</tt>µַװַ
     * 
     * @param namespace
     * @param key
     * @param value
     * @return
     */
    Long append(int namespace, String key, String value);

    /**
     * õStringλ<tt>start</tt><tt>end</tt>ַ
     * 
     * @param namespace
     * @param key
     * @param start
     * @param end
     * @return
     */
    String get(int namespace, String key, long start, long end);

    /**
     * <tt>offset</tt>ʼ滻Ϊ<tt>value</tt>
     * 
     * @param namespace
     * @param key
     * @param value
     * @param offset
     */
    void set(int namespace, String key, String value, long offset);

    /**
     * ȡַ
     * 
     * @param namespace
     * @param key
     * @return
     */
    Long size(int namespace, String key);

    /**
     * ݣѾڣ򸲸ǣڣ
     * 
     * @param namespace
     *            ڵnamespace
     * @param key
     * @param value
     */
    void set(int namespace, String key, String value);

    /**
     * ݣѾڣ򸲸ǣڣ
     * 
     * @param namespace
     *            ڵnamespace
     * @param key
     * @param value
     * @param timeout
     *            ݵЧʱ
     * @param unit
     *            ʱ䵥λ
     */
    void set(int namespace, String key, String value, long timeout, TimeUnit unit);

    /**
     * ݣѾڣԭֵ<tt>false</tt>ڣ<tt>true</tt>
     * 
     * @param namespace
     *            ڵnamespace
     * @param key
     * @param value
     * @return ݲڷ<tt>true</tt>򷵻<tt>false</tt>
     */
    Boolean setIfAbsent(int namespace, String key, String value);

    /**
     * 
     * 
     * @param namespace
     * @param m
     */
    void multiSet(int namespace, Map<String, String> m);

    /**
     * ݣֻеݲʱ
     * 
     * @param namespace
     * @param m
     */
    void multiSetIfAbsent(int namespace, Map<String, String> m);

    /**
     * ȡ עⲻô˷ȥȡincrementkey
     * 
     * @param namespace
     * @param key
     * @return
     */
    String get(int namespace, Object key);

    /**
     * ͬʱݣ˷ԭӲ עⲻô˷ȥȡincrementkey
     * 
     * @param namespace
     * @param key
     * @param value
     * @return
     */
    String getAndSet(int namespace, String key, String value);

    /**
     * ȡ עⲻô˷ȥȡincrementkey
     * 
     * @param namespace
     * @param keys
     * @return
     */
    List<String> multiGet(int namespace, Collection<String> keys);

}
